import { EventEmitter, TemplateRef, ViewContainerRef, OnInit, OnDestroy } from '@angular/core';
import { ResponsiveState } from '../config/config';
import { responsivePattern } from '../config/interfaces';
export declare class Responsive implements OnInit, OnDestroy {
    templateRef: TemplateRef<Object>;
    private _responsiveState;
    private viewContainer;
    responsive: string | string[];
    changes: EventEmitter<any>;
    set_values: responsivePattern;
    private set_active_subscriptions;
    private match_multiple;
    private _subscription_Bootstrap;
    private _subscription_Browser;
    private _subscription_Pixel_Ratio;
    private _subscription_Device;
    private _subscription_Orientation;
    private _subscription_Standard;
    private _subscription_IE_Version;
    private _subscription_custom_sizes;
    protected _showWhenTrue: boolean;
    private _globalNoRepeat;
    private _noRepeatBootstrapName;
    private _bootstrapNoRepeat;
    private _deviceNoRepeat;
    private _standardNoRepeat;
    private _orientationNoRepeat;
    private _browserNoRepeat;
    private _pixelratioNoRepeat;
    private _ieNoRepeat;
    private _sizesNoRepeat;
    private _bootstrap_user_param;
    private _devices_user_param;
    private _standard_user_param;
    private _orientation_user_param;
    private _browser_user_param;
    private _pixelratio_user_param;
    private _ie_user_param;
    private _sizes_user_param;
    private _sizes_window;
    protected _actives: string[];
    /*** CONSTRUCTOR ***/
    constructor(templateRef: TemplateRef<Object>, _responsiveState: ResponsiveState, viewContainer: ViewContainerRef);
    init_responsive(value: any): void;
    ngOnInit(): void;
    private updateBootstrap(value);
    private updateBrowser(value);
    private updateDevice(value);
    private updatePixelRatio(value);
    private updateOrientation(value);
    private updateStandard(value);
    private updateIEversion(value);
    private updateSizes(value);
    private updateEvent(param, type_directive);
    private showHideOperations(show, type_directive);
    private matchValues(show, type_directive);
    ngOnDestroy(): void;
    private _ifValueChanged(oldValue, newValue);
    private isJSON(value);
}
